/* 
 * CS5App.java for Hw4Pr1
 *
 * Name:
 * Homework: 4
 * Problem:  1
 *
 * Comments on this program:
 *
 */

import java.io.*;
import java.net.*;
import java.awt.Color;
import H.*;

class CS5App
{
	
	static public MyUpdater myupdater;
	static public RobotFrame2 map;
	static public RobotFrame irsensors;
	static public ControlPanel cpanel;
	static public ER1 er1;
	static public EnvMap envMap;
	static public EnvMap irMap;
	
	public static void quitAll()
	{
		if (er1 != null)
		{
			er1.shutDown();
		}
		
		if (map != null)
		{
        	map.dispose();
		}
		
		if (irsensors != null)
		{
        	irsensors.dispose();
		}
        
		if (cpanel != null)
		{
			cpanel.dispose();
		}

        System.exit(0); 
	}
	
    public static void main2(String args[])
    {
        ER1.configure();
        myupdater = new MyUpdater(100);
        
        map = new RobotFrame2(Color.white);
        irsensors = new RobotFrame(Color.lightGray);
        cpanel = new ControlPanel(Color.white);
        
        envMap = new EnvMap(EnvMap.MAP);
        
        // must be after the environment so that the 
        // pfilter will have bounds for initialization
        er1 = new ER1();     // starts simulated
        
        //H.pl("Point 1");
        map.setUpdater(myupdater);
        //irsensors.setUpdater(myupdater);
        
        //H.pl("Point 2");
        
        myupdater.addItem(er1); // should be first!
        myupdater.addItem(map.centerPanel);
        myupdater.addItem(irsensors.centerPanel);
        
        //H.pl("Point 3");

        map.addDrawable(er1);
        map.addDrawable(envMap);
        
        //H.pl("Point 4");
        
        irMap = new EnvMap(EnvMap.IR);
        irsensors.addDrawable(irMap);
        
        cpanel.setBounds(0,0,370,400);
        map.setBounds(0,400,1018,506);
        irsensors.setBounds(370,0,351,176);
        
        //H.pl("Point 5");
        
        if (!myupdater.isAlive())
        	myupdater.start();
        
    } // end of main2
		
	public static void main(String[] args)
	{
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
    		public void run() {
        	    main2(null);
    		}
		});
	}
    
} // end of CS5App




