import java.awt.*;
import java.awt.event.*;
import java.util.LinkedList;
import javax.swing.*;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.StreamTokenizer;
import H.*;

class ControlPanel extends JFrame
{ 
    public JPanel centerPanel = new JPanel();
    public JPanel southPanel = new JPanel();
    
    public JButton forward = new JButton();
    public JButton wander = new JButton();
    public JButton backward = new JButton();
    public JButton left = new JButton();
    public JButton turnAround = new JButton();
    public JButton right = new JButton();
    
    public JButton stop = new JButton();
    public JButton speedup = new JButton();
    public JButton slowdown = new JButton();
    
    public JButton update = new JButton();
    public JButton updateIR = new JButton();
    public JButton updateENC = new JButton();
    
    public JButton prog1 = new JButton();
    public JButton prog2 = new JButton();
    public JButton prog3 = new JButton();
    public JButton prog4 = new JButton();
    
    public JButton vel = new JButton();
    
    public JTextField vTrans = new JTextField("0.0",12);
    public JTextField vRot  = new JTextField("0.0",12);
    
    public JTextField ir_nw = new JTextField("ir_nw",12);
    public JTextField ir_n  = new JTextField("ir_n",12);
    public JTextField ir_ne = new JTextField("ir_ne",12);
    
    public JTextField xEnc = new JTextField("x estimate",12);
    public JTextField yEnc  = new JTextField("y estimate",12);
    public JTextField thetaEnc = new JTextField("theta est.",12);
    public JTextField time = new JTextField("time",12);
    
    public JLabel stopLabel = new JLabel("STOP");
    
    public Font font;
    
    public ControlPanel() 
    {         
        addListeners();
        initFrame();
    }
    
    public ControlPanel(Color c)   // specify the background color of the center panel
    {
        addListeners();
        initFrame();
        centerPanel.setBackground(c);
        // see JFrame for this -- it doesn't seem to make a difference
        //setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    }
    
    private void addListeners()
    {
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                dispose();
                System.exit(0);
            }
        });
        /*
        addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent e) {
                centerPanel.resizeHandler();
            }
        });
        */
    }
    
    private void initFrame() 
    {
        H.pl("Initializing the GUI ...");

        this.setSize(400, 400);
        this.setTitle("CS5AppGr");
        font = new Font("Helvetica", Font.PLAIN, 12);
        
        
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        centerPanel.setLayout(gridbag);
        
        // this.getContentPane().setLayout(null);
        
        // fix up our center panel
        centerPanel.setVisible(true);
        centerPanel.setBackground(Color.blue);
        
        // fix up our south panel
        southPanel.setVisible(true);
        southPanel.setBackground(Color.red);
        
        // general layout constraint
        c.fill = GridBagConstraints.BOTH;
        
        
        
        // FORWARD BUTTON
        forward.setVisible(true);
        forward.setText("Forward");
        forward.setFont(font);
        forward.setBackground(Color.WHITE);
        forward.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("forward button pressed!");
                handleForward();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridwidth = 1; //GridBagConstraints.REMAINDER;
        //c.weighty = 1.0;
        gridbag.setConstraints(forward, c);
        centerPanel.add(forward);
        
        // WANDER BUTTON
        wander.setVisible(true);
        wander.setText("Wander");
        wander.setFont(font);
        wander.setBackground(Color.WHITE);
        wander.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("wander button pressed!");
                handleWander();
                //CS5App.er1.WANDER_STATE = ER1.WANDER;
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridwidth = 1; //GridBagConstraints.REMAINDER;
        //c.weighty = 1.0;
        gridbag.setConstraints(wander, c);
        centerPanel.add(wander);
        
        // BACKWARD BUTTON
        backward.setVisible(true);
        backward.setText("Backward");
        backward.setFont(font);
        backward.setBackground(Color.WHITE);
        backward.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("backward button pressed!");
                handleBackward();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(backward, c);
        centerPanel.add(backward);
        c.weightx = 0.0;
        
        // LEFT button
        left.setVisible(true);
        left.setText("Left");
        left.setFont(font);
        left.setBackground(Color.WHITE);
        left.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("left button pressed!");
                handleLeft();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 2.0;
        c.gridwidth = 1;//GridBagConstraints.RELATIVE;
        c.gridheight = 2;
        gridbag.setConstraints(left, c);
        centerPanel.add(left);
        
        // TURNAROUND button
        turnAround.setVisible(true);
        turnAround.setText("180");
        turnAround.setFont(font);
        turnAround.setBackground(Color.WHITE);
        turnAround.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("turnAround button pressed!");
                handleTurnaround();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 2.0;
        c.gridwidth = 1; //GridBagConstraints.RELATIVE;
        c.gridheight = 2;
        gridbag.setConstraints(turnAround, c);
        centerPanel.add(turnAround);

        
        // RIGHT button
        right.setVisible(true);
        right.setText("Right");
        right.setFont(font);
        right.setBackground(Color.WHITE);
        right.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("right button pressed!");
                handleRight();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 2.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        c.gridheight = 2;
        gridbag.setConstraints(right, c);
        centerPanel.add(right);
 /*       
        // update button
        update.setVisible(true);
        update.setText("Update Data");
        update.setFont(font);
        update.setBackground(Color.WHITE);
        update.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("update button pressed!");
                handleUpdate();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridheight = 1;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(update, c);
        centerPanel.add(update);
        
        // updateIR button
        updateIR.setVisible(true);
        updateIR.setText("Update IR Data");
        updateIR.setFont(font);
        updateIR.setForeground(Color.WHITE);
        updateIR.setBackground(Color.blue);
        updateIR.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("updateIR button pressed!");
                handleUpdateIR();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridheight = 1;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(updateIR, c);
        centerPanel.add(updateIR);
        
        // updateENC button
        updateENC.setVisible(true);
        updateENC.setText("Update ENC Data");
        updateENC.setFont(font);
        updateENC.setForeground(Color.white);
        updateENC.setBackground(Color.green);
        updateENC.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("updateENC button pressed!");
                handleUpdateENC();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridheight = 1;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(updateENC, c);
        centerPanel.add(updateENC);
  */      
        // ir_nw text field
        ir_nw.setVisible(true);
        ir_nw.setBackground(Color.WHITE);
        ir_nw.setEditable(true);
        ir_nw.setFont(font);
        ir_nw.setForeground(Color.blue);
        ir_nw.setHorizontalAlignment(JTextField.CENTER);
        ir_nw.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("ir_nw textfield edited!");
                handleUpdateIR_nw();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridheight = 1;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(ir_nw, c);
        centerPanel.add(ir_nw);
        
        // xEnc text field
        xEnc.setVisible(true);
        xEnc.setBackground(Color.WHITE);
        xEnc.setEditable(true);
        xEnc.setFont(font);
        xEnc.setForeground(Color.green);
        xEnc.setHorizontalAlignment(JTextField.CENTER);
        xEnc.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("xEnc textfield edited!");
                handleUpdateENC_x();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridheight = 1;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(xEnc, c);
        centerPanel.add(xEnc);
        
        // ir_n text field
        ir_n.setVisible(true);
        ir_n.setBackground(Color.WHITE);
        ir_n.setEditable(true);
        ir_n.setFont(font);
        ir_n.setForeground(Color.blue);
        ir_n.setHorizontalAlignment(JTextField.CENTER);
        ir_n.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("ir_n textfield edited!");
                handleUpdateIR_n();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridheight = 1;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(ir_n, c);
        centerPanel.add(ir_n);
        
        // yEnc text field
        yEnc.setVisible(true);
        yEnc.setBackground(Color.WHITE);
        yEnc.setEditable(true);
        yEnc.setFont(font);
        yEnc.setForeground(Color.green);
        yEnc.setHorizontalAlignment(JTextField.CENTER);
        yEnc.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("yEnc textfield edited!");
                handleUpdateENC_y();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridheight = 1;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(yEnc, c);
        centerPanel.add(yEnc);
        
        // ir_ne text field
        ir_ne.setVisible(true);
        ir_ne.setBackground(Color.WHITE);
        ir_ne.setEditable(true);
        ir_ne.setFont(font);
        ir_ne.setForeground(Color.blue);
        ir_ne.setHorizontalAlignment(JTextField.CENTER);
        ir_ne.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("ir_ne textfield edited!");
                handleUpdateIR_ne();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridheight = 1;
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(ir_ne, c);
        centerPanel.add(ir_ne);
        
        // thetaEnc text field
        thetaEnc.setVisible(true);
        thetaEnc.setBackground(Color.WHITE);
        thetaEnc.setEditable(true);
        thetaEnc.setFont(font);
        thetaEnc.setForeground(Color.green);
        thetaEnc.setHorizontalAlignment(JTextField.CENTER);
        thetaEnc.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("thetaEnc textfield edited!");
                handleUpdateENC_theta();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridheight = 1;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(thetaEnc, c);
        centerPanel.add(thetaEnc);
        
        // TIME button
        time.setVisible(true);
        time.setBackground(Color.WHITE);
        time.setEditable(true);
        time.setFont(font);
        time.setHorizontalAlignment(JTextField.CENTER);
        time.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Time button pressed!");
                handleTime();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(time, c);
        centerPanel.add(time);
        
        // PROG1 button
        prog1.setVisible(true);
        prog1.setForeground(Color.magenta);
        prog1.setBackground(Color.WHITE);
        prog1.setFont(font);
        prog1.setText("Connect");
        prog1.setHorizontalAlignment(JTextField.CENTER);
        prog1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Prog1 button pressed!");
                handleProg(1);
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridwidth = 1;
        gridbag.setConstraints(prog1, c);
        centerPanel.add(prog1);
        
        // PROG2 button
        prog2.setVisible(true);
        prog2.setForeground(Color.magenta);
        prog2.setBackground(Color.WHITE);
        prog2.setFont(font);
        prog2.setText("Talk");
        prog2.setHorizontalAlignment(JTextField.CENTER);
        prog2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Prog2 button pressed!");
                handleProg(2);
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridwidth = 1;
        gridbag.setConstraints(prog2, c);
        centerPanel.add(prog2);
        
        // PROG3 button
        prog3.setVisible(true);
        prog3.setForeground(Color.magenta);
        prog3.setBackground(Color.white);
        prog3.setFont(font);
        prog3.setText("Quit");
        prog3.setHorizontalAlignment(JTextField.CENTER);
        prog3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Prog3 button pressed!");
                handleProg(3);
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridwidth = 1;
        gridbag.setConstraints(prog3, c);
        centerPanel.add(prog3);
        
        // PROG4 button
        prog4.setVisible(true);
        prog4.setForeground(Color.black);
        prog4.setBackground(Color.WHITE);
        prog4.setFont(font);
        prog4.setText("Program");
        prog4.setHorizontalAlignment(JTextField.CENTER);
        prog4.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Prog4 button pressed!");
                handleProg(4);
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(prog4, c);
        centerPanel.add(prog4);
        
        // VELOCITY button
        vel.setVisible(true);
        vel.setText("Velocities (trans and rot)");
        vel.setFont(font);
        vel.setBackground(Color.WHITE);
        vel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Vel button pressed!");
                handleVels();
            }
        });
        // layout stuff
        c.weightx = 0.0;
        c.weighty = 0.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(vel, c);
        centerPanel.add(vel);
        
        
        // VTRANS textfield
        vTrans.setVisible(true);
        vTrans.setForeground(Color.black);
        vTrans.setBackground(Color.WHITE);
        vTrans.setFont(font);
        vTrans.setText("0.0");
        vTrans.setHorizontalAlignment(JTextField.CENTER);
        vTrans.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("vTrans button pressed!");
                handleVTrans();
            }
        });
        // layout stuff
        c.gridwidth = GridBagConstraints.RELATIVE;
        gridbag.setConstraints(vTrans, c);
        centerPanel.add(vTrans);
        
        // VROT textfield
        vRot.setVisible(true);
        vRot.setForeground(Color.black);
        vRot.setBackground(Color.WHITE);
        vRot.setFont(font);
        vRot.setText("0.0");
        vRot.setHorizontalAlignment(JTextField.CENTER);
        vRot.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("vRot button pressed!");
                handleVRot();
            }
        });
        // layout stuff
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(vRot, c);
        centerPanel.add(vRot);
        
        
        // STOP button
        stop.setVisible(true);
        stop.setText("Stop");
        stop.setFont(font);
        stop.setBackground(Color.RED);
        stop.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Stop button pressed!");
                handleStop();
            }
        });
        // layout stuff
        c.weightx = 1.0;
        c.weighty = 3.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(stop, c);
        centerPanel.add(stop);
        
		/*
        stopLabel.setVisible(true);
        stopLabel.setBackground(Color.WHITE);
		southPanel.add(stopLabel);
		*/
        
        // add panels to the enclosing frame (OuterFrame)
        this.getContentPane().add(centerPanel,BorderLayout.CENTER);
        //this.getContentPane().add(southPanel,BorderLayout.SOUTH);
        this.setVisible(true);
        
        /*
         * start the threading object (updater)
         */
        //updater.addItem(centerPanel);
        //updater.setSleepTime(5);
        //updater.start();
        
        /*
         * associate the centerPanel with our objects to be drawn
         */
        //Drawable.setPanel(centerPanel);
    }
    
    public void handleProg(int prognum)
    {
    	//H.pl("in Prog handler wth prognum = " + prognum);
    	switch (prognum)
    	{
    		case 4: 
    		{
    			// user-defined program here...
    			//H.pl("User-defined program");
    			ER1.IN_PROGRAM++;
       			break;
    		}
    		
    		case 3:  // #3 is for quitting the server and this program ? altogether
    		{
    			CS5App.er1.exchangeWithServer("q"); // quits the server
    			// CS5App.er1.shutDown();  // clean up and go to simulated mode
    			// well, we need a clean way to clean everything up... this could be it
    			CS5App.quitAll(); // do we want to quit the program?
    			break;
    		}
    		
    		case 2:
    		{
    		    H.pl("What would you like to do?");
    		    H.pl(" (1) Print Window parameters");
    		    H.pl(" (2) Talk to the server");
    		    int i =H.ni();
    		    if (i == 2) 
    		    {
        			// talk to the server
        			if (CS5App.er1 != null)
        			{
        				CS5App.er1.serverTalk(); // this probably needs to be in another thread!
        			}
        		}
        		else
        		{
        		  H.pl("Control Panel x,y,w,h: " + this.getX() + " "  +
        		  this.getY() + " " + this.getWidth() + " " + this.getHeight());
        		  H.pl("Map Panel x,y,w,h: " + CS5App.map.getX() + " "  +
                  CS5App.map.getY() + " " + CS5App.map.getWidth() + " " + CS5App.map.getHeight());
                  H.pl("irsensors Panel x,y,w,h: " + CS5App.irsensors.getX() + " "  +
                  CS5App.irsensors.getY() + " " + CS5App.irsensors.getWidth() + " " + CS5App.irsensors.getHeight());
        		}
    			break;
    		}
    		
    		case 1: 
    		{
    			// connect or disconnect from the server
    			// how?
    			// 1) check if connected (simulated or not)
    			if (CS5App.er1.realRobot())
    			{
    				// disconnect gracefully
    				H.pl("Disconnecting");
    				CS5App.er1.shutDown();
    			}
    			else
    			{
    				// connect
    				H.pl("Connecting");
    				CS5App.er1.setUpConnection();
    			}
    			break;
    		}

    		default: H.pl("Unhandled prognum = " + prognum); break;
    	}
    }
    
    public void handleWander()
    {
        if (ER1.WANDER_STATE == ER1.REMOTE_CONTROL)
        {
            ER1.WANDER_STATE = ER1.WANDER;
        }
        else
        {
            ER1.WANDER_STATE =ER1.REMOTE_CONTROL;
        }
        this.repaint();
    }
    
    public void handleForward()
    {
    	CS5App.er1.handleForward();
    	this.repaint();
    	/*
    	String s = CS5App.er1.getGoString(ER1.FORWARD);
    	H.pl("Sending: " + s);
    	CS5App.er1.exchangeWithServer(s);
    	*/
    }
    
    public void handleBackward()
    {
    	CS5App.er1.handleBackward();
    	this.repaint();
    	/*
    	String s = CS5App.er1.getGoString(ER1.BACKWARD);
    	H.pl("Sending: " + s);
    	CS5App.er1.exchangeWithServer(s);
    	*/
    }
    
    public void handleLeft()
    {
    	CS5App.er1.handleLeft();
    	this.repaint();
    	/*
    	String s = CS5App.er1.getGoString(ER1.LEFT);
    	H.pl("Sending: " + s);
    	CS5App.er1.exchangeWithServer(s);
    	*/
    }
    
    public void handleTurnaround()
    {
        CS5App.er1.handleStop();
        CS5App.er1.WANDER_STATE = ER1.TURNAROUND;
        this.repaint();
        /*
        String s = CS5App.er1.getGoString(ER1.LEFT);
        H.pl("Sending: " + s);
        CS5App.er1.exchangeWithServer(s);
        */
    }
    
    public void handleRight()
    {
    	CS5App.er1.handleRight();
    	this.repaint();
    	/*
    	String s = CS5App.er1.getGoString(ER1.RIGHT);
    	H.pl("Sending: " + s);
    	CS5App.er1.exchangeWithServer(s);
    	*/
    }
    
    public void handleStop()
    {
    	H.pl("Stopping");
    	CS5App.er1.handleStop(); // exchangeWithServer("z");
    	this.repaint();
    }
    
    public void handleUpdate()
    {
    	String s = CS5App.er1.exchangeWithServer("AllData");
    	//H.pl("the returned string is " + s);
    	String[] L = s.split("\\s+");
    	double[] Lvals = new double[L.length];
    	//H.pl("The split strings (and values) are");
    	for (int i=1 ; i<L.length ; ++i) // first is "Message: "
    	{
    		Lvals[i] = Double.parseDouble(L[i]);
    		//H.pl("i="+ i + "  " + L[i] + "  " + Lvals[i]);
    	}
    	
    	xEnc.setText(""+Lvals[1]);
    	yEnc.setText(""+Lvals[2]);
    	thetaEnc.setText(""+Lvals[3]);
    	time.setText(""+Lvals[4]);
    	
    	ir_nw.setText(""+Lvals[5]);
    	ir_n.setText(""+Lvals[6]);
    	ir_ne.setText(""+Lvals[7]);
    	this.repaint();
    }

    public void handleUpdateIR()
    {
    	//H.pl("in updateIR handler");
    	handleUpdate();
    }

    public void handleUpdateENC()
    {
    	//H.pl("in updateENC handler");
    	handleUpdate();
    }       
    
    public void handleUpdateIR_nw()
    {
    	//H.pl("in updateIR_nw handler");
    } 
    
    public void handleUpdateIR_n()
    {
    	//H.pl("in updateIR_n handler");
    }
    
    public void handleUpdateIR_ne()
    {
    	//H.pl("in updateIR_ne handler");
    }
    
    public void handleUpdateENC_x()
    {
    	//H.pl("in updateENC_x handler");
    }
    
    public void handleUpdateENC_y()
    {
    	//H.pl("in updateENC_y handler");
    }
    
    public void handleUpdateENC_theta()
    {
    	//H.pl("in updateENC_theta handler");
    }
    
    public void handleTime()
    {
    	//H.pl("in time handler");
    }
    
    public void handleVels()
    {
    	//H.pl("in velocities handler");
    }
    
    public void handleVTrans()
    {
    	//H.pl("in vTrans handler");
    	// need try... catch on the parsing..
    	double d = 0.0;
    	try {
    		d = Double.parseDouble(vTrans.getText());
    	} catch (Exception e) {
    		e.printStackTrace();
    		d = 0.0;
    	}
    	H.pl("Setting trans vel to " + d);
    	CS5App.er1.setVTrans(d);
    }
    
    public void handleVRot()
    {
    	//H.pl("in vRot handler");
    	// need try... catch on the parsing...
    	double d = 0.0;
    	try {
    		d = Double.parseDouble(vRot.getText());
    	} catch (Exception e) {
    		e.printStackTrace();
    		d = 0.0;
    	}
    	H.pl("Setting rot. vel to " + d);
    	CS5App.er1.setVRot(d);
    }
    
    public void updateSize()
    {
        // by default, increase by 1 pixel
        updateSize(1,1);
    }
    
    public void updateSize(int delta_w, int delta_h)
    {
        Dimension dim = this.getSize();
        dim.height++;
        dim.width++;
        this.setSize(dim);
    }
}
	