import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.LinkedList;
import javax.swing.*;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.StreamTokenizer;
import H.*;

class Drawable
{
    protected JPanel m_canvas = null;
    protected Graphics2D g;
    protected int height;
    protected int width;
    
    public AffineTransform currentAT;
    
    protected LinkedList screenObjects = new LinkedList();
    
    public void setPanel(JPanel canvasIn)
    {
        m_canvas = canvasIn;
        resizeHandler();   // if we have a new panel, it's a new size!
    }
    
     public void resizeHandler()
    {
        if (m_canvas == null) return;  // nothing's there yet!
        
        //H.pl("The window has been resized... adjusting...");  
        height = m_canvas.getHeight();
        width = m_canvas.getWidth();      
        
        int listlen = screenObjects.size();
        
        for (int i=0 ; i<listlen ; ++i)
        {
            Drawable d = (Drawable)(screenObjects.get(i));
            d.handleResizeEvent();
        }
        // redraw will be handled by Swing
    }
    
     public void nextStepList()
    {
        int listlen = screenObjects.size();
        
        for (int i=0 ; i<listlen ; ++i)
        {
            Drawable d = (Drawable)(screenObjects.get(i));
            d.nextStep();
        }
    }
    
     public void drawList(Graphics g_in)
    {
    	if (g_in == null)
    	{
    		H.pl("the graphics in drawList was null!");
    		return;
    	}
    	
        if (g_in instanceof Graphics2D)  
        {
            g = (Graphics2D)(g_in);   
        }
        else 
        {
            H.pl("Not a Graphics2D!");
            return;
        }
        
        int listlen = screenObjects.size();
        
        AffineTransform savedAT = g.getTransform();
        g.transform(currentAT);
        g.setColor(Color.blue);
        for (int i=0 ; i<listlen ; ++i)
        {
            Drawable d = (Drawable)(screenObjects.get(i));
            d.draw();
        }
        currentAT.translate(50,50);
        currentAT.rotate(Math.toRadians(10));
        g.transform(currentAT);
        g.setColor(Color.red);
        for (int i=0 ; i<listlen ; ++i)
        {
            Drawable d = (Drawable)(screenObjects.get(i));
            d.draw();
        }
        currentAT.setToIdentity();
        g.setTransform(savedAT);
    }
    

    public Drawable()
    {
    	currentAT = new AffineTransform();
        //register();
    } 
    
   
    public void draw(Graphics2D g)
    {
        ;
    }
    
    public void draw()
    {
        ;
    }
    
    public void nextStep()
    {
        ;
    }
    
    public void handleResizeEvent()
    {
        ;
    }
}
	