import java.awt.geom.*;
import java.util.Vector;
import H.*;


class Geo
{
	
	public static boolean inEnvironment(double x, double y)
	{
		// takes a point in global coordinates
		// checks how many intersections there are above it 
		// if odd, it's in; if even, it's out
		
		// upLine, because it faces up...
		// topy is how far up...
		double topy = -1000;
		Line2D.Double upLine = new Line2D.Double(x,y,x,topy);
		
		Vector lines = CS5App.envMap.obstacles;
		       
		Line2D.Double L  = null; 
		int count = 0;
				      
		for (int i=0 ; i<lines.size() ; ++i)	
		{
			Object o = lines.get(i);
			//H.pl("i is " + i);
			
			if (o instanceof Line2D.Double)
			{
				L = (Line2D.Double)o;
				if (L.intersectsLine(upLine)) 
				{
					++count;
				}
			}
		}
		
		if (count%2 == 1)
			return true;
		else
			return false;
	}
	
	// taken from http://forum.java.sun.com/thread.jsp?thread=179628&forum=20&message=747493
	public static Point2D.Double getIntersectionPoint(Line2D.Double line1, Line2D.Double line2) 
	{    
		if (!line1.intersectsLine(line2)) return null;      
		
		double px = line1.getX1(), py = line1.getY1(), rx = line1.getX2()-px, ry = line1.getY2()-py;     
		double qx = line2.getX1(), qy = line2.getY1(), sx = line2.getX2()-qx, sy = line2.getY2()-qy;     
		double det = sx*ry - sy*rx;      
		
		if (det == 0) 
		{ 
			return null; 
	    } 
		else 
		{    
			double z = (sx*(qy-py)+sy*(px-qx))/det;        
			//if (z==0 ||  z==1) return null;  // intersection at end point!  OK for us      
			return new Point2D.Double( (px+z*rx), (py+z*ry));
	    } 
	} // end intersection line-line
	
	public static double distToNearestWall(double irx, double iry, double irt)
	{
		return distToNearestWall( irx,  iry, irt, false);
	}
	
	public static double distToNearestWall(double irx, double iry, double irt, boolean flag)  // already radians, flag for drawing
	{
		double scale = 2000.0;
		Line2D.Double irline = new Line2D.Double(irx,iry,irx + scale*Math.cos(irt), iry + scale*Math.sin(irt));
		                  
		//H.pl("irline is (" + irline.getX1() + "," + irline.getY1() + ") - (" + irline.getX2() + "," + irline.getY2() + ")");
		                  
		Vector lines = CS5App.envMap.obstacles;
		       
		Line2D.Double L  = null; 
		Line2D.Double Lsaved = null;
		Point2D.Double P = null;
		Point2D.Double P2 = new Point2D.Double(irx,iry);
		double min = 2000;  
		double d = 2000;  
		      
		for (int i=0 ; i<lines.size() ; ++i)
		{
			Object o = lines.get(i);
			//H.pl("i is " + i);
			
			if (o instanceof Line2D.Double)
			{
				L = (Line2D.Double)o;
				
				P = getIntersectionPoint(irline,L);
				if (P!=null)
				{
				    //H.pl("L is (" + L.getX1() + "," + L.getY1() + ") - (" + L.getX2() + "," + L.getY2() + ")");
					CS5App.envMap.extraSeg = L;
					CS5App.map.repaint();
					//H.p("Intersection: " + P.getX() + "," + P.getY());
					d = P2.distance(P);
					//H.pl("   dist: " + d);
					if (d > 0.0 && d < min) 
					{
						min = d;
						Lsaved = L;
					}
			    }
			    else
			    {
			    	//H.pl("P was null");
			    }
			}
			//H.pl("Enter a string to continue");
			//String s = H.nl();
			
		}
		
		if (flag) {
		
			H.pl("min is " + min);
			if (Lsaved != null)  // for drawing the segment
			{
				H.pl("L is (" + Lsaved.getX1() + "," + Lsaved.getY1() + ") - (" + Lsaved.getX2() + "," + Lsaved.getY2() + ")");
				CS5App.envMap.extraSeg = Lsaved;
		    }
		    
	    }
	    
	    // limiting the range of the IR sensors
		if (min > 75) // effective IR range, if there is nothing with in 75 units of the sensor, it is free space
		{
			min = 75;
		}
		
		return min;
	}
}