import java.awt.*;
import java.awt.event.*;
import java.util.LinkedList;
import javax.swing.*;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.StreamTokenizer;
import H.*;

class OuterFrame extends UpdaterFrame
{    
    private JPanel centerPanel = new MyPanel();
    private JPanel southPanel = new JPanel();
    private JButton button1 = new JButton();
    private JButton button2 = new JButton();
    
    public OuterFrame() 
    {         
        addListeners();
        initFrame();
    }
    
    public OuterFrame(Color c)   // specify the background color of the center panel
    {
        addListeners();
        initFrame();
        centerPanel.setBackground(c);
        // see JFrame for this -- it doesn't seem to make a difference
        //setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    }
    
    private void addListeners()
    {
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                dispose();
                System.exit(0);
            }
        });
        
        addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent e) {
                //Drawable.resizeHandler();
            }
        });
    }

    private void initFrame() 
    {
        H.pl("Initializing the GUI ...");

        this.setSize(400, 400);
        this.setTitle("CS5AppGr");
        
        // this.getContentPane().setLayout(null);
        
        // fix up our center panel
        centerPanel.setVisible(true);
        centerPanel.setBackground(Color.black);
        
        // fix up our south panel
        southPanel.setVisible(true);
        southPanel.setBackground(Color.black);
        
        // objects to be added to the south panel
        button1.setVisible(true);
        button1.setText("Go/Stop");
        //button1.setBackground(Color.WHITE);
        button1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Button pressed!");
                updater.toggle();
            }
        });
        
        button2.setVisible(true);
        button2.setText("Draw");
        button2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Button pressed!");
                updater.step(1);
            }
        });
        
        // add objects to the south panel
        //southPanel.add(button1);
        southPanel.add(button2); // we add only button 2 for the drawing application 
        
        // add panels to the enclosing frame (OuterFrame)
        this.getContentPane().add(centerPanel,BorderLayout.CENTER);
        this.getContentPane().add(southPanel,BorderLayout.SOUTH);
        this.setVisible(true);
        
        /*
         * start the threading object (updater)
         */
        updater.addItem(centerPanel);
        //updater.setSleepTime(5);
        //updater.start();
        
        /*
         * associate the centerPanel with our objects to be drawn
         */
        //Drawable.setPanel(centerPanel);
    }
    
    public void updateSize()
    {
        // by default, increase by 1 pixel
        updateSize(1,1);
    }
    
    public void updateSize(int delta_w, int delta_h)
    {
        Dimension dim = this.getSize();
        dim.height++;
        dim.width++;
        this.setSize(dim);
    }
}
	