import java.awt.*;
import java.awt.event.*;
import java.util.LinkedList;
import javax.swing.*;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.StreamTokenizer;
import H.*;

class RobotFrame extends JFrame
{    
    public MyPanel centerPanel = new MyPanel();
    public JPanel southPanel = new JPanel();

    
    

    
    //public Vector
    
    public RobotFrame() 
    {         
        addListeners();
        initFrame();
    }
    
    public RobotFrame(Color c)   // specify the background color of the center panel
    {
        addListeners();
        initFrame();
        centerPanel.setBackground(c);
        // see JFrame for this -- it doesn't seem to make a difference
        //setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    }
    
    private void addListeners()
    {
    	
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                dispose();
                System.exit(0);
            }
        });
        
        addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent e) {
                centerPanel.resizeHandler();
            }
        });
        
    }

    private void initFrame() 
    {
        H.pl("Initializing the GUI ...");

        this.setSize(400, 400);
        this.setTitle("CS5AppGr");
        
        // this.getContentPane().setLayout(null);
        
        // fix up our center panel
        centerPanel.setVisible(true);
        centerPanel.setBackground(Color.black);
        
        // fix up our south panel
        southPanel.setVisible(true);
        southPanel.setBackground(Color.black);
        

        
        // add panels to the enclosing frame (OuterFrame)
        this.getContentPane().add(centerPanel,BorderLayout.CENTER);
        this.getContentPane().add(southPanel,BorderLayout.SOUTH);
        this.setVisible(true);
        
        /*
         * start the threading object (updater)
         */
        //updater.addItem(centerPanel);
        //updater.setSleepTime(5);
        //updater.start();
        
        /*
         * associate the centerPanel with our objects to be drawn
         */
        //Drawable.setPanel(centerPanel);
    }
    
    // pass-through to the relevant panel...
    public void addDrawable(Drawable d)
    {
    	centerPanel.addDrawable(d);
    }
    
    public void updateSize()
    {
        // by default, increase by 1 pixel
        updateSize(1,1);
    }
    
    public void updateSize(int delta_w, int delta_h)
    {
        Dimension dim = this.getSize();
        dim.height++;
        dim.width++;
        this.setSize(dim);
    }
}
	